package fi.em.formPlugin;

import kd.bos.bill.AbstractBillPlugIn;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.datamodel.ListSelectedRow;
import kd.bos.entity.datamodel.ListSelectedRowCollection;
import kd.bos.entity.datamodel.events.ChangeData;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.exception.KDBizException;
import kd.bos.form.CloseCallBack;
import kd.bos.form.ShowFormHelper;
import kd.bos.form.control.Control;
import kd.bos.form.events.ClosedCallBackEvent;
import kd.bos.form.field.TextEdit;
import kd.bos.list.ListShowParameter;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.sdk.plugin.Plugin;

import java.util.EventObject;

public class YwclBankListtenerFromPlugin extends AbstractBillPlugIn implements Plugin {
    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        // 对字段(文本控件)添加点击监听
        TextEdit textEdit = getControl("nckd_payeebanknumlb");
        textEdit.addClickListener(this);
        TextEdit textEdits = getControl("nckd_payeebanknumlbs");
        textEdits.addClickListener(this);
    }
    @Override
    public void click(EventObject evt) {
        Control control = (Control) evt.getSource();
        String key = control.getKey();
        // 点击供应商11111
        if (com.alibaba.druid.util.StringUtils.equalsIgnoreCase("nckd_payeebanknumlb", key)) {
            String billpayertype = this.getModel().getValue("nckd_itemclasstypefield1").toString();
            if("".equals(billpayertype)){
                throw new KDBizException("往来类型为空！");
            }
            if("bd_supplier".equals(billpayertype)){
                ListShowParameter parameter = ShowFormHelper.createShowListForm("nckd_supplierbankinfor", false);
                parameter.setCloseCallBack(new CloseCallBack(this, "nckd_supplierbankinfor"));
                DynamicObject skdata = (DynamicObject)this.getModel().getValue("nckd_payeenamev");
                if(skdata ==null){
                    throw new KDBizException("付款方为空！");
                }
                long orgid = skdata.getLong("id");
                QFilter nckd_skzjFilter = new QFilter("id", QCP.equals,orgid);
                DynamicObject dynamicObject = BusinessDataServiceHelper.loadSingle("bd_supplier", "id", new QFilter[]{nckd_skzjFilter});
                QFilter filter;
                //给基础资料添加过滤
                filter = new QFilter("nckd_id", QCP.equals, dynamicObject.getLong("id"));
                parameter.getListFilterParameter().setFilter(filter);
                getView().showForm(parameter);
            } else if ("bos_user".equals(billpayertype)) {
                ListShowParameter parameter = ShowFormHelper.createShowListForm("er_payeer", false);
                parameter.setCloseCallBack(new CloseCallBack(this, "er_payeer"));
                DynamicObject skdata = (DynamicObject)this.getModel().getValue("nckd_payeenamev");
                if(skdata ==null){
                    throw new KDBizException("收款方为空！");
                }
                long orgid = skdata.getLong("id");
                QFilter nckd_skzjFilter = new QFilter("id", QCP.equals,orgid);
                DynamicObject dynamicObject = BusinessDataServiceHelper.loadSingle("bos_user", "id", new QFilter[]{nckd_skzjFilter});
                QFilter filter;
                //给基础资料添加过滤
                filter = new QFilter("payer.id", QCP.equals, dynamicObject.getLong("id"));
                parameter.getListFilterParameter().setFilter(filter);
                getView().showForm(parameter);
            } else if ("bos_org".equals(billpayertype)) {
                ListShowParameter parameter = ShowFormHelper.createShowListForm("bos_org", false);
                parameter.setCloseCallBack(new CloseCallBack(this, "bos_org"));
                DynamicObject skdata = (DynamicObject)this.getModel().getValue("nckd_payeenamev");
                if(skdata ==null){
                    throw new KDBizException("收款方为空！");
                }
                long orgid = skdata.getLong("id");
                QFilter nckd_skzjFilter = new QFilter("id", QCP.equals,orgid);
                DynamicObject dynamicObject = BusinessDataServiceHelper.loadSingle("bos_org", "id", new QFilter[]{nckd_skzjFilter});
                QFilter filter;
                //给基础资料添加过滤
                filter = new QFilter("id", QCP.equals, dynamicObject.getLong("id"));
                parameter.getListFilterParameter().setFilter(filter);
                getView().showForm(parameter);
            }
        } else{
            if (com.alibaba.druid.util.StringUtils.equalsIgnoreCase("nckd_payeebanknumlbs", key)) {
                String billpayertype = this.getModel().getValue("nckd_itemclasstypefield").toString();
                if("bd_supplier".equals(billpayertype)){
                    ListShowParameter parameter = ShowFormHelper.createShowListForm("nckd_supplierbankinfor", false);
                    parameter.setCloseCallBack(new CloseCallBack(this, "nckd_supplierbankinfor"));
                    DynamicObject skdata = (DynamicObject)this.getModel().getValue("nckd_payeenamevs");
                    if(skdata ==null){
                        throw new KDBizException("收款人为空！");
                    }
                    long orgid = skdata.getLong("id");
                    QFilter nckd_skzjFilter = new QFilter("id", QCP.equals,orgid);
                    DynamicObject dynamicObject = BusinessDataServiceHelper.loadSingle("bd_supplier", "id", new QFilter[]{nckd_skzjFilter});
                    QFilter filter;
                    //给基础资料添加过滤
                    filter = new QFilter("nckd_id", QCP.equals, dynamicObject.getLong("id"));
                    parameter.getListFilterParameter().setFilter(filter);
                    getView().showForm(parameter);
                } else if ("bos_user".equals(billpayertype)) {
                    ListShowParameter parameter = ShowFormHelper.createShowListForm("er_payeer", false);
                    parameter.setCloseCallBack(new CloseCallBack(this, "er_payeer"));
                    DynamicObject skdata = (DynamicObject)this.getModel().getValue("nckd_payeenamevs");
                    if(skdata ==null){
                        throw new KDBizException("收款人为空！");
                    }
                    long orgid = skdata.getLong("id");
                    QFilter nckd_skzjFilter = new QFilter("id", QCP.equals,orgid);
                    DynamicObject dynamicObject = BusinessDataServiceHelper.loadSingle("bos_user", "id", new QFilter[]{nckd_skzjFilter});
                    QFilter filter;
                    //给基础资料添加过滤
                    filter = new QFilter("payer.id", QCP.equals, dynamicObject.getLong("id"));
                    parameter.getListFilterParameter().setFilter(filter);
                    getView().showForm(parameter);
                } else if ("bos_org".equals(billpayertype)) {
                    ListShowParameter parameter = ShowFormHelper.createShowListForm("bos_org", false);
                    parameter.setCloseCallBack(new CloseCallBack(this, "bos_org"));
                    DynamicObject skdata = (DynamicObject)this.getModel().getValue("nckd_payeenamevs");
                    if(skdata ==null){
                        throw new KDBizException("收款人为空！");
                    }
                    long orgid = skdata.getLong("id");
                    QFilter nckd_skzjFilter = new QFilter("id", QCP.equals,orgid);
                    DynamicObject dynamicObject = BusinessDataServiceHelper.loadSingle("bos_org", "id", new QFilter[]{nckd_skzjFilter});
                    QFilter filter;
                    //给基础资料添加过滤
                    filter = new QFilter("id", QCP.equals, dynamicObject.getLong("id"));
                    parameter.getListFilterParameter().setFilter(filter);
                    getView().showForm(parameter);
                }


            }
        }
        super.click(evt);
    }
    @Override
    public void closedCallBack(ClosedCallBackEvent evt) {
        String key = evt.getActionId();
        Object returnData = evt.getReturnData();
        // 将选择的采购申请单数据回写至样例单据上的相应字段
        Object nckdDetailtype = this.getModel().getValue("nckd_detailtype");
        if (com.alibaba.druid.util.StringUtils.equalsIgnoreCase("nckd_supplierbankinfor", key) && returnData != null) {
            ListSelectedRow row = ((ListSelectedRowCollection) returnData).get(0);
            DynamicObject billObj = BusinessDataServiceHelper.loadSingle(row.getPrimaryKeyValue(), "nckd_supplierbankinfor");
            if("B".equals(nckdDetailtype)){
                this.getModel().setValue("nckd_payeebanknumlbs", billObj.getString("nckd_bankaccount"));
                this.getModel().setValue("nckd_payeebanknamelbs", billObj.getString("nckd_accountname"));
                //刷新分录
                this.getView().updateView("nckd_payeebanknumlbs");
                this.getView().updateView("nckd_payeebanknamelbs");
            } else if ("A".equals(nckdDetailtype)) {
                this.getModel().setValue("nckd_payeebanknumlb", billObj.getString("nckd_bankaccount"));
                this.getModel().setValue("nckd_textfield55", billObj.getString("nckd_accountname"));
                //刷新分录
                this.getView().updateView("nckd_payeebanknumlb");
                this.getView().updateView("nckd_textfield55");
            }
        } else if (com.alibaba.druid.util.StringUtils.equalsIgnoreCase("er_payeer", key) && returnData != null) {
            ListSelectedRow row = ((ListSelectedRowCollection) returnData).get(0);
            DynamicObject billObj = BusinessDataServiceHelper.loadSingle(row.getPrimaryKeyValue(), "er_payeer");
            DynamicObject payerbank = billObj.getDynamicObject("payerbank");
            if("B".equals(nckdDetailtype)){
                this.getModel().setValue("nckd_payeebanknumlbs", payerbank.getString("number"));
                this.getModel().setValue("nckd_payeebanknamelbs", payerbank.getString("name"));
                //刷新分录
                this.getView().updateView("nckd_payeebanknumlbs");
                this.getView().updateView("nckd_payeebanknamelbs");
            } else if ("A".equals(nckdDetailtype)) {
                this.getModel().setValue("nckd_payeebanknumlb", payerbank.getString("number"));
                this.getModel().setValue("nckd_textfield55", payerbank.getString("name"));
                //刷新分录
                this.getView().updateView("nckd_payeebanknumlb");
                this.getView().updateView("nckd_textfield55");
            }
        } else if (com.alibaba.druid.util.StringUtils.equalsIgnoreCase("bos_org", key) && returnData != null) {
            ListSelectedRow row = ((ListSelectedRowCollection) returnData).get(0);
            DynamicObject billObj = BusinessDataServiceHelper.loadSingle(row.getPrimaryKeyValue(), "bos_org");
            if("B".equals(nckdDetailtype)){
                this.getModel().setValue("nckd_payeebanknumlbs", billObj.getString("bankaccount"));
                this.getModel().setValue("nckd_payeebanknamelbs", billObj.getString("ffirmname"));
                //刷新分录
                this.getView().updateView("nckd_payeebanknumlbs");
                this.getView().updateView("nckd_payeebanknamelbs");
            } else if ("A".equals(nckdDetailtype)) {
                this.getModel().setValue("nckd_payeebanknumlb", billObj.getString("bankaccount"));
                this.getModel().setValue("nckd_textfield55", billObj.getString("ffirmname"));
                //刷新分录
                this.getView().updateView("nckd_payeebanknumlb");
                this.getView().updateView("nckd_textfield55");
            }
        }
        super.closedCallBack(evt);
    }
    @Override
    public void propertyChanged(PropertyChangedArgs e) {
        super.beforePropertyChanged(e);
        String name = e.getProperty().getName();//获取字段标识
        if ("nckd_payeenamev".equals(name)) {
            ChangeData[] changeSet = e.getChangeSet();//获取值
            for (ChangeData changeData : changeSet) {
                int rowIndex = changeData.getRowIndex();
                Object newValue = changeData.getNewValue();
                Object oldValue = changeData.getOldValue();
                DynamicObject payeenamevs = (DynamicObject) newValue;
                String billpayertype = this.getModel().getValue("nckd_itemclasstypefield1").toString();
                if("bd_supplier".equals(billpayertype)){
                    this.getModel().setValue("nckd_payeebanknumlb",null);//行号
                    this.getModel().setValue("nckd_textfield55",null);//行名
                    //刷新分录
                    this.getView().updateView("nckd_payeebanknumlb");
                    this.getView().updateView("nckd_textfield55");
                    QFilter nckd = new QFilter("id", QCP.equals,payeenamevs.getLong("id"));
                    payeenamevs = BusinessDataServiceHelper.loadSingle("bd_supplier", new QFilter[]{nckd});
                    if(payeenamevs!=null){
                        for (DynamicObject entryentity : payeenamevs.getDynamicObjectCollection("entry_bank")) {
                            String bankaccount = entryentity.getString("bankaccount");
                            String accountname = entryentity.getString("accountname");
                            String isdefaultBank = entryentity.getString("isdefault_bank");
                            DynamicObject bank = entryentity.getDynamicObject("bank");
                            if("true".equals(isdefaultBank)){
                                this.getModel().setValue("nckd_payeebanknumlb", bankaccount);
                                this.getModel().setValue("nckd_textfield55", accountname);
                                this.getView().updateView("nckd_payeebanknumlb");
                                this.getView().updateView("nckd_textfield55");

                            }
                        }
                    }
                } else if ("bos_user".equals(billpayertype)) {
                    this.getModel().setValue("nckd_payeebanknumlb",null);//行号
                    this.getModel().setValue("nckd_textfield55",null);//行名
                    //刷新分录
                    this.getView().updateView("nckd_payeebanknumlb");
                    this.getView().updateView("nckd_textfield55");
                    QFilter nckd = new QFilter("id", QCP.equals,payeenamevs.getLong("id"));
                    payeenamevs = BusinessDataServiceHelper.loadSingle("bos_user", new QFilter[]{nckd});
                    if(payeenamevs!=null){
                        QFilter nckd_skzjFilter = new QFilter("payer.id", QCP.equals,payeenamevs.getLong("id"));
                        nckd_skzjFilter.and("isdefault", QCP.equals, "1");
                        DynamicObject dynamicObject = BusinessDataServiceHelper.loadSingle("er_payeer", new QFilter[]{nckd_skzjFilter});
                        if(dynamicObject!=null){
                            DynamicObject payerbank = dynamicObject.getDynamicObject("payerbank");
                            this.getModel().setValue("nckd_payeebanknumlb", payerbank.getString("number"));//行号
                            this.getModel().setValue("nckd_textfield55", payerbank.getString("name"));//行名
                            //刷新分录
                            this.getView().updateView("nckd_payeebanknumlb");
                            this.getView().updateView("nckd_textfield55");

                        }
                    }
                } else if ("bos_org".equals(billpayertype)) {
                    this.getModel().setValue("nckd_payeebanknumlb",null);//行号
                    this.getModel().setValue("nckd_textfield55",null);//行名
                    //刷新分录
                    this.getView().updateView("nckd_payeebanknumlb");
                    this.getView().updateView("nckd_textfield55");
                    QFilter nckd = new QFilter("id", QCP.equals,payeenamevs.getLong("id"));
                    payeenamevs = BusinessDataServiceHelper.loadSingle("bos_org", new QFilter[]{nckd});
                    if(payeenamevs!=null){

                        this.getModel().setValue("nckd_payeebanknumlb", payeenamevs.getString("bankaccount"));
                        this.getModel().setValue("nckd_textfield55", payeenamevs.getString("ffirmname"));
                        //刷新分录
                        this.getView().updateView("nckd_payeebanknumlb");
                        this.getView().updateView("nckd_textfield55");
                    }
                }

            }
        }else if ("nckd_payeenamevs".equals(name)) {
            ChangeData[] changeSet = e.getChangeSet();//获取值
            for (ChangeData changeData : changeSet) {
                int rowIndex = changeData.getRowIndex();
                Object newValue = changeData.getNewValue();
                Object oldValue = changeData.getOldValue();
                DynamicObject payeenamevs = (DynamicObject) newValue;
                String billpayertype = this.getModel().getValue("nckd_itemclasstypefield").toString();
                if("bd_supplier".equals(billpayertype)){
                    this.getModel().setValue("nckd_payeebanknumlbs",null);//行号
                    this.getModel().setValue("nckd_payeebanknamelbs",null);//行名
                    //刷新分录
                    this.getView().updateView("nckd_payeebanknumlbs");
                    this.getView().updateView("nckd_payeebanknamelbs");
                    QFilter nckd = new QFilter("id", QCP.equals,payeenamevs.getLong("id"));
                    payeenamevs = BusinessDataServiceHelper.loadSingle("bd_supplier", new QFilter[]{nckd});
                    if(payeenamevs!=null){
                        for (DynamicObject entryentity : payeenamevs.getDynamicObjectCollection("entry_bank")) {
                            String bankaccount = entryentity.getString("bankaccount");
                            String accountname = entryentity.getString("accountname");
                            String isdefaultBank = entryentity.getString("isdefault_bank");
                            DynamicObject bank = entryentity.getDynamicObject("bank");
                            if("true".equals(isdefaultBank)){
                                this.getModel().setValue("nckd_payeebanknumlbs", bankaccount);
                                this.getModel().setValue("nckd_payeebanknamelbs", accountname);
                                this.getView().updateView("nckd_payeebanknumlbs");
                                this.getView().updateView("nckd_payeebanknamelbs");

                            }
                        }
                    }
                } else if ("bos_user".equals(billpayertype)) {
                    this.getModel().setValue("nckd_payeebanknumlbs",null);//行号
                    this.getModel().setValue("nckd_payeebanknamelbs",null);//行名
                    //刷新分录
                    this.getView().updateView("nckd_payeebanknumlbs");
                    this.getView().updateView("nckd_payeebanknamelbs");
                    QFilter nckd = new QFilter("id", QCP.equals,payeenamevs.getLong("id"));
                    payeenamevs = BusinessDataServiceHelper.loadSingle("bos_user", new QFilter[]{nckd});
                    if(payeenamevs!=null){
                        QFilter nckd_skzjFilter = new QFilter("payer.id", QCP.equals,payeenamevs.getLong("id"));
                        nckd_skzjFilter.and("isdefault", QCP.equals, "1");
                        DynamicObject dynamicObject = BusinessDataServiceHelper.loadSingle("er_payeer", new QFilter[]{nckd_skzjFilter});
                        if(dynamicObject!=null){
                            DynamicObject payerbank = dynamicObject.getDynamicObject("payerbank");
                            this.getModel().setValue("nckd_payeebanknumlbs", payerbank.getString("number"));//行号
                            this.getModel().setValue("nckd_payeebanknamelbs", payerbank.getString("name"));//行名
                            //刷新分录
                            this.getView().updateView("nckd_payeebanknumlbs");
                            this.getView().updateView("nckd_payeebanknamelbs");

                        }
                     }
                } else if ("bos_org".equals(billpayertype)) {
                    this.getModel().setValue("nckd_payeebanknumlbs",null);//行号
                    this.getModel().setValue("nckd_payeebanknamelbs",null);//行名
                    //刷新分录
                    this.getView().updateView("nckd_payeebanknumlbs");
                    this.getView().updateView("nckd_payeebanknamelbs");
                    QFilter nckd = new QFilter("id", QCP.equals,payeenamevs.getLong("id"));
                    payeenamevs = BusinessDataServiceHelper.loadSingle("bos_org", new QFilter[]{nckd});
                    if(payeenamevs!=null){
                        this.getModel().setValue("nckd_payeebanknumlbs", payeenamevs.getString("bankaccount"));
                        this.getModel().setValue("nckd_payeebanknamelbs", payeenamevs.getString("ffirmname"));
                        //刷新分录
                        this.getView().updateView("nckd_payeebanknumlbs");
                        this.getView().updateView("nckd_payeebanknamelbs");
                    }
                }

            }
        }else if("nckd_itemclasstypefield1".equals(name)){
            this.getModel().setValue("nckd_payeebanknumlb",null);//行号
            this.getModel().setValue("nckd_textfield55",null);//行名
            //刷新分录
            this.getView().updateView("nckd_payeebanknumlb");
            this.getView().updateView("nckd_textfield55");
        }else if("nckd_itemclasstypefield".equals(name)){
            this.getModel().setValue("nckd_payeebanknumlbs",null);//行号
            this.getModel().setValue("nckd_payeebanknamelbs",null);//行名
            //刷新分录
            this.getView().updateView("nckd_payeebanknumlbs");
            this.getView().updateView("nckd_payeebanknamelbs");
        }

    }
}
